# Stake from DFNS

{% hint style="warning" %}
Kiln is a non-custodial staking provider. As a customer and owner of your assets, **it is YOUR responsibility to check and verify all the transactions you are signing**. While Kiln provides tooling to help you interact with your stakes (web applications, APIs), **Kiln is not responsible for the transactions that you sign.**
{% endhint %}

| Asset           | Stake via UI | Stake via API |
| --------------- | ------------ | ------------- |
| Ethereum (ETH)  | ✅            | ✅             |
| Polygon (POL)   |              | ✅             |
| Algorand (ALGO) |              | ⏳             |
| Cardano (ADA)   |              | ✅             |
| Solana (SOL)    |              | ✅             |
| Tezos (XTZ)     |              | ✅             |
| Tron (TRX)      |              | ⏳             |
| IOTA            |              | ✅             |

## Ethereum (ETH)

### Stake via UI

Ethereum can easily be staked using the Kiln Dashboard connected via WalletConnect to your DFNS account, as shown in this demo video:&#x20;

{% embed url="<https://www.youtube.com/watch?v=-2c2v5H8Zg4>" %}

### Stake via API&#x20;

The Kiln Connect API can be used to generate ETH validation keys to be funded in a deposit transaction. The deposit transaction can be issued programmatically using the DFNS API. Get in touch with your Kiln account manager to set this up!

## Stake all other protocols via API

Use [Kiln Connect](https://docs.kiln.fi/v1/kiln-products/connect) to craft staking transactions for any of the above protocols, then leverage DFNS's [Broadcast Transaction](https://docs.dfns.co/d/api-docs/wallets/broadcast-transaction-from-wallet) to sign and broadcast them.

* See the DFNS API spec [here](https://docs.dfns.co/d/api-docs/api-docs)
* See the different Sign and Broadcast endpoints [here](https://docs.dfns.co/d/api-docs/wallets/broadcast-transaction-from-wallet)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.kiln.fi/v1/integrations/custody-platforms/stake-from-dfns.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
